
from django.test import TestCase

from .models import Post, PostSerializer


class MagicFieldTestCase(TestCase):

    def setUp(self):
        for i in range(10):
            Post.objects.create(user=i, title="article %s" % i, content="body %s" % i)

    def test_get_object(self):
        post = Post.objects.first()
        self.assertEqual(post.user, {'id': 0, 'username': 'username 0'})

    def test_get_queryset(self):
        """
        pass
        :return:
        """
        posts = Post.objects.all()[:10]
        serializer = PostSerializer(posts, many=True)
        for idx, obj in enumerate(serializer.data):
            self.assertEqual(obj['user'], {'id': idx, 'username': 'username %s' % idx})

    def test_get_queryset_lazy(self):
        posts = Post.objects.all()[:10]
        serializer = PostSerializer(posts, many=True, lazy=True)
        for idx, obj in enumerate(serializer.data):
            self.assertEqual(obj['user'], idx)

    def test_query_column(self):
        queryset = Post.objects.filter(user_id=1)
        print(queryset)
        obj = Post.objects.get(user_id=1)
        print(obj)
