# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from rest_framework import viewsets
from rest_framework import routers

from gm_rpcd.all import bind

from .models import Post, PostSerializer


class MagicViewSets(viewsets.ModelViewSet):

    def __call__(self, *args, **kwargs):
        method = kwargs.pop("__method__", "get").lower()
        if method in self.http_method_names:
            handler = getattr(self, method, self.http_method_not_allowed)
        else:
            handler = self.http_method_not_allowed
        return handler(*args, **kwargs)


class PostViewSets(MagicViewSets):

    def get(self, *args, **kwargs):
        post = Post.objects.first()
        return PostSerializer(post).data

    def post(self, *args, **kwargs):
        serializer = PostSerializer(data=kwargs)
        if serializer.is_valid():
            serializer.save()
            return serializer.data

bind('gm_serializer/post')(PostViewSets())

PostViewSets()(**{'pk': 1, '__method__': 'GET'})
PostViewSets()(**{'user': 1, 'title': 'tt', 'content': 'cc', '__method__': 'POST'})
